<#	
	.NOTES
	===========================================================================
	 Created with: 	SAPIEN Technologies, Inc., PowerShell Studio 2019 v5.6.161
	 Created on:   	4/3/2019 7:15 PM
	 Created by:   	max_t
	 Organization: 	SAPIEN Technologies, Inc.
	 Filename:  WriteProgressSample03.ps1   	
	===========================================================================
	.DESCRIPTION
		A description of the file.

."C:\Users\xxxx\Documents\SAPIEN\Scripts\WriteProgressSamples\WriteProgressSample03.ps1"

#>

Clear-Host;

## - Initializing variables:
$Svrlist = @($env:COMPUTERNAME, $env:COMPUTERNAME);
$TotalSteps = 4;
$Id = 1;
$loopCnt = 1;

## - Foreach to process all tasks:
$SysInfoResults = foreach ($name in $SvrList)
{

	## ------------- Step 1 Settings -------------------------
	$Step = 1;
	$Task = "Begin Collecting Information";
	$StepText = "[$($loopCnt)] - Collecting Information for Server: $($name)";
	$StatusText = "Start Process!";
	
	## - Display Text only progress:	
	Write-Progress -Id $Id -Activity $StepText -CurrentOperation $Task -Status $StatusText;
	
	## - Slight delay:
	Start-Sleep -Seconds 10;
	
	## ------------- Step 2 Settings -------------------------
	$Step = 2;
	$StepText = "--> [$($loopCnt)] $($name) - Getting OS";
	$Task = "Extracting Server OS Information";
	$StatusText = "Step $($Step) In Process";
	
	## - Run WMI Win32_OperatingSystem command:
	$x = get-wmiObject -Class Win32_OperatingSystem -Computername $name `
				   -ErrorAction 'SilentlyContinue' -ErrorVariable MyError;

	## - Display Progress Bar:		
	Write-Progress -Id $Id `
	-Activity $StepText `
	-Status $StatusText `
	-CurrentOperation $Task `
	-PercentComplete (($Step / $TotalSteps) * 100);
	
	## - Slight delay:
	Start-Sleep -Seconds 10;
	
	## ------------- Step 3 Settings -------------------------
	$Step = 3;
	$StepText = "--> [$($loopCnt)] $($name) - Getting Computer";
	$Task = "Extracting Computer Information";
	$StatusText = "Step $($Step) In Process";
	
	## - Run WMI Win32_ComputerSystem command:
	$x1 = Get-WmiObject -Class Win32_ComputerSystem -Computername $name `
					-ErrorAction 'SilentlyContinue' -ErrorVariable MyError;
					
## - Display Progress Bar:	
	Write-Progress -Id $Id `
	-Activity $StepText `
	-Status $StatusText `
	-CurrentOperation $Task `
	-PercentComplete (($Step / $TotalSteps)*100);
	
	## - Slight delay:
	Start-Sleep -Seconds 10;
	
	## ------------- Step 4 Settings -------------------------
	$Step = 4;
	$StepText = "--> [$($loopCnt)] $($name) - Create PSObject";
	$Task = "Build Computer PSObject";
	$StatusText = "Step $($Step) In Process";
	
	## - Build Computer system info PSObject:
	[PSCustomObject]$SystemInfo = New-Object PSObject -Property @{
		CntID = $Id;
		ComputerName = $x.csname;
		OS = $x.Name.Split('|')[0];
		LastBootUpTime = $x.ConvertToDateTime($x.LastBootUpTime);
		Status	     = "Success";
		Manufacturer = $x1.manufacturer;
		SystemModel  = $x1.model;
		'PhysicalMemory(GB)' = [float]($x1.TotalPhysicalMemory/1gb);
	}; $SystemInfo

	## - Display Progress Bar:	
	Write-Progress -Id $Id `
	-Activity $StepText `
	-Status $StatusText `
	-CurrentOperation $Task `
	-PercentComplete (($Step / $TotalSteps) * 100);
	
	## - Slight delay:
	Start-Sleep -Seconds 10;
	
	## - Increment loop counter variable:
	$loopCnt++

};

## - Display results in Console:
$SysInfoResults
